local part = {}
local prv = {}

--
-- Part definition
--
part.meta = {
    caption = "Hello World",
    definition = {
        {
            caption = "Basic",
            items = {         
                { caption= "Data Object", path = 'path', type='variable', data_type = 'text' },                
            }        
        },
    }
}

--
-- Public part declarations 
--  

--- This function is called by the run-time to render output. This function shall use the print(...) 
-- function to write the rendered output to the web-page. This function is called in the present cycle 
-- of a form or form-part node.
--
-- @param self (input/output) instance of part execution, containing all part-parameters values set in the net; data written into self-structure in the function body can be accessed in part-action-functions.
-- @param ctx (input/output) current application / session context; mostly the same as the <gctx>
-- @param id (input) unique id of the part based on the net, token and node; this id is reproducible, so a next execution of the same part in the same node in the same net will result into the same id
-- @param gctx (input/output) global application / session context
part.write = function (self, _, ctx, _, id, gctx)
    -- include libraries
    local dobject = require 'logicnets.dataobject'
    require 'logicnets.output'
    
    -- read data from context
    local value = dobject.get(ctx, self.path)
    
    -- render output
    logicnets.output.print('Hello' .. value)
end

return part -- the part declaration is passed back to the run-time